package com.esignlive.guidance.forum;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.Reader;
import java.net.HttpURLConnection;
import java.net.ProtocolException;
import java.net.URL;
import java.util.Date;

import com.silanis.esl.sdk.DocumentPackage;
import com.silanis.esl.sdk.EslClient;
import com.silanis.esl.sdk.EslException;
import com.silanis.esl.sdk.PackageId;
import com.silanis.esl.sdk.builder.DocumentPackageSettingsBuilder;
import com.silanis.esl.sdk.builder.PackageBuilder;
import com.silanis.esl.sdk.builder.SignerBuilder;

public class _09_25_notary_signer {
	public static final String API_KEY = "your_api_key";
	public static final String API_URL = "https://sandbox.esignlive.com/api";
	public static final String notaryRoleId = "notary";
	public static final String notaryEmail = "notary_email";
    
	public static void main(String[] args) {
		 EslClient eslClient = new EslClient(API_KEY, API_URL);
		 try {
	         //step1: add notary as signer and mark "notarized" for package
	         DocumentPackage pkg1 = PackageBuilder.newPackageNamed("Create Notary Package by Java SDK - " + new Date())
                                            .withSigner(SignerBuilder.newSignerWithEmail(notaryEmail)
                                                     .withFirstName("Duo")
                                                     .withLastName("Liang")
                                                     .withCustomId(notaryRoleId)
                                                     )
                                            .withNotarized(true)
                                            .withSettings(DocumentPackageSettingsBuilder.newDocumentPackageSettings()
                                                                     .hideOwnerInPersonDropDown()
                                                         )
                                            .build();
	
	         PackageId createPackageOneStep = eslClient.createPackageOneStep(pkg1);
	         System.out.println("package id: "+ createPackageOneStep);
	
	         //step2: set notary role id (by custom REST method)
			 setNotaryRoleId(createPackageOneStep.getId(), notaryRoleId);
		} catch (IOException ioEx) {
			ioEx.printStackTrace();
		} catch(EslException eslEx) {
			eslEx.printStackTrace();
		}
		
	}
	
	 private static void setNotaryRoleId(String packageId, String notaryId) throws IOException {
 		URL sourceClient = new URL(API_URL + "/packages/" + packageId);
 		HttpURLConnection sourceConn = (HttpURLConnection) sourceClient.openConnection();
 		sourceConn.setRequestProperty("Content-Type", "application/json; esl-api-version=11.21");
 		sourceConn.setRequestProperty("Accept", "application/json; esl-api-version=11.21");
 		sourceConn.setRequestProperty("Authorization", "Basic " + API_KEY);
 		sourceConn.setRequestMethod("POST");
 		sourceConn.setDoOutput(true);
 		sourceConn.setDoInput(true);

        String payloadJSON = "{\"notaryRoleId\" : \"" + notaryId + "\"}";
 		System.out.println(payloadJSON);
 		OutputStream os = sourceConn.getOutputStream();
 		os.write(payloadJSON.toString().getBytes());
 		os.flush();
 		os.close();	

 		int sourceResponseCode = ((HttpURLConnection) sourceConn).getResponseCode();
 		if (sourceResponseCode != 200) {
 			Reader ir = new InputStreamReader(sourceConn.getErrorStream());
 			BufferedReader in = new BufferedReader(ir);
 			String inputLine;
 			StringBuffer response = new StringBuffer();

 			while ((inputLine = in.readLine()) != null) {
 				response.append(inputLine);
 			}

 			in.close();
 			sourceConn.disconnect();
 			throw new RuntimeException(response.toString());
 		}

     }



}
